import numpy as np
import matplotlib.pyplot as plt
import matplotlib
import scipy.constants
from mpl_toolkits.axes_grid.inset_locator import (inset_axes, InsetPosition, mark_inset)
import scipy.constants as sc

#----------------------------------------------------------------------------------------------------------------------------------------------------#

font = {'size'   : 13}

matplotlib.rc('font', **font)

#-----------------------------------------------------load data------------------------------------------------------------------
#CR for Bx
data_CR_Bx_0T  = np.loadtxt('./CR/Bx/Bx_0T/data_theta0_lambdaSO_0.006_B_mag_0_phi_0_lambdaA_0_lambdaB_0_CR.dat')
data_CR_Bx_1T  = np.loadtxt('./CR/Bx/Bx_1T/data_theta0_lambdaSO_0.006_B_mag_1_phi_0_lambdaA_0_lambdaB_0_CR.dat')
data_CR_Bx_2T  = np.loadtxt('./CR/Bx/Bx_2T/data_theta0_lambdaSO_0.006_B_mag_2_phi_0_lambdaA_0_lambdaB_0_CR.dat')
data_CR_Bx_3T  = np.loadtxt('./CR/Bx/Bx_3T/data_theta0_lambdaSO_0.006_B_mag_3_phi_0_lambdaA_0_lambdaB_0_CR.dat')
data_CR_Bx_m1T = np.loadtxt('./CR/Bx/Bx_-1T/data_theta0_lambdaSO_0.006_B_mag_-1_phi_0_lambdaA_0_lambdaB_0_CR.dat')
data_CR_Bx_m2T = np.loadtxt('./CR/Bx/Bx_-2T/data_theta0_lambdaSO_0.006_B_mag_-2_phi_0_lambdaA_0_lambdaB_0_CR.dat')
data_CR_Bx_m3T = np.loadtxt('./CR/Bx/Bx_-3T/data_theta0_lambdaSO_0.006_B_mag_-3_phi_0_lambdaA_0_lambdaB_0_CR.dat')

#CR for By
data_CR_By_0T  = np.loadtxt('./CR/By/By_0T/data_theta0_lambdaSO_0.006_B_mag_0_phi_90_lambdaA_0_lambdaB_0_CR.dat')
data_CR_By_1T  = np.loadtxt('./CR/By/By_1T/data_theta0_lambdaSO_0.006_B_mag_1_phi_90_lambdaA_0_lambdaB_0_CR.dat')
data_CR_By_2T  = np.loadtxt('./CR/By/By_2T/data_theta0_lambdaSO_0.006_B_mag_2_phi_90_lambdaA_0_lambdaB_0_CR.dat')
data_CR_By_3T  = np.loadtxt('./CR/By/By_3T/data_theta0_lambdaSO_0.006_B_mag_3_phi_90_lambdaA_0_lambdaB_0_CR.dat')
data_CR_By_m1T = np.loadtxt('./CR/By/By_-1T/data_theta0_lambdaSO_0.006_B_mag_-1_phi_90_lambdaA_0_lambdaB_0_CR.dat')
data_CR_By_m2T = np.loadtxt('./CR/By/By_-2T/data_theta0_lambdaSO_0.006_B_mag_-2_phi_90_lambdaA_0_lambdaB_0_CR.dat')
data_CR_By_m3T = np.loadtxt('./CR/By/By_-3T/data_theta0_lambdaSO_0.006_B_mag_-3_phi_90_lambdaA_0_lambdaB_0_CR.dat')

#DR for Bx
data_DR_Bx_0T  = np.loadtxt('./D/Bx/Bx_0T/data_theta90_lambdaSO_0.006_B_mag_0_phi_0_lambdaA_0_lambdaB_0_D.dat')
data_DR_Bx_1T  = np.loadtxt('./D/Bx/Bx_1T/data_theta90_lambdaSO_0.006_B_mag_1_phi_0_lambdaA_0_lambdaB_0_D.dat')
data_DR_Bx_2T  = np.loadtxt('./D/Bx/Bx_2T/data_theta90_lambdaSO_0.006_B_mag_2_phi_0_lambdaA_0_lambdaB_0_D.dat')
data_DR_Bx_3T  = np.loadtxt('./D/Bx/Bx_3T/data_theta90_lambdaSO_0.006_B_mag_3_phi_0_lambdaA_0_lambdaB_0_D.dat')
data_DR_Bx_m1T = np.loadtxt('./D/Bx/Bx_-1T/data_theta90_lambdaSO_0.006_B_mag_-1_phi_0_lambdaA_0_lambdaB_0_D.dat')
data_DR_Bx_m2T = np.loadtxt('./D/Bx/Bx_-2T/data_theta90_lambdaSO_0.006_B_mag_-2_phi_0_lambdaA_0_lambdaB_0_D.dat')
data_DR_Bx_m3T = np.loadtxt('./D/Bx/Bx_-3T/data_theta90_lambdaSO_0.006_B_mag_-3_phi_0_lambdaA_0_lambdaB_0_D.dat')

#DR for By
data_DR_By_0T  = np.loadtxt('./D/By/By_0T/data_theta90_lambdaSO_0.006_B_mag_0_phi_90_lambdaA_0_lambdaB_0_D.dat')
data_DR_By_1T  = np.loadtxt('./D/By/By_1T/data_theta90_lambdaSO_0.006_B_mag_1_phi_90_lambdaA_0_lambdaB_0_D.dat')
data_DR_By_2T  = np.loadtxt('./D/By/By_2T/data_theta90_lambdaSO_0.006_B_mag_2_phi_90_lambdaA_0_lambdaB_0_D.dat')
data_DR_By_3T  = np.loadtxt('./D/By/By_3T/data_theta90_lambdaSO_0.006_B_mag_3_phi_90_lambdaA_0_lambdaB_0_D.dat')
data_DR_By_m1T = np.loadtxt('./D/By/By_-1T/data_theta90_lambdaSO_0.006_B_mag_-1_phi_90_lambdaA_0_lambdaB_0_D.dat')
data_DR_By_m2T = np.loadtxt('./D/By/By_-2T/data_theta90_lambdaSO_0.006_B_mag_-2_phi_90_lambdaA_0_lambdaB_0_D.dat')
data_DR_By_m3T = np.loadtxt('./D/By/By_-3T/data_theta90_lambdaSO_0.006_B_mag_-3_phi_90_lambdaA_0_lambdaB_0_D.dat')


#RR for Bx
data_RR_Bx_0T  = np.loadtxt('./RR/Bx/Bx_0T/data_theta90_lambdaSO_0.006_B_mag_0_phi_0_lambdaA_0_lambdaB_0_RR.dat')
data_RR_Bx_1T  = np.loadtxt('./RR/Bx/Bx_1T/data_theta90_lambdaSO_0.006_B_mag_1_phi_0_lambdaA_0_lambdaB_0_RR.dat')
data_RR_Bx_2T  = np.loadtxt('./RR/Bx/Bx_2T/data_theta90_lambdaSO_0.006_B_mag_2_phi_0_lambdaA_0_lambdaB_0_RR.dat')
data_RR_Bx_3T  = np.loadtxt('./RR/Bx/Bx_3T/data_theta90_lambdaSO_0.006_B_mag_3_phi_0_lambdaA_0_lambdaB_0_RR.dat')
data_RR_Bx_m1T = np.loadtxt('./RR/Bx/Bx_-1T/data_theta90_lambdaSO_0.006_B_mag_-1_phi_0_lambdaA_0_lambdaB_0_RR.dat')
data_RR_Bx_m2T = np.loadtxt('./RR/Bx/Bx_-2T/data_theta90_lambdaSO_0.006_B_mag_-2_phi_0_lambdaA_0_lambdaB_0_RR.dat')
data_RR_Bx_m3T = np.loadtxt('./RR/Bx/Bx_-3T/data_theta90_lambdaSO_0.006_B_mag_-3_phi_0_lambdaA_0_lambdaB_0_RR.dat')

#RR for By
data_RR_By_0T  = np.loadtxt('./RR/By/By_0T/data_theta90_lambdaSO_0.006_B_mag_0_phi_90_lambdaA_0_lambdaB_0_RR.dat')
data_RR_By_1T  = np.loadtxt('./RR/By/By_1T/data_theta90_lambdaSO_0.006_B_mag_1_phi_90_lambdaA_0_lambdaB_0_RR.dat')
data_RR_By_2T  = np.loadtxt('./RR/By/By_2T/data_theta90_lambdaSO_0.006_B_mag_2_phi_90_lambdaA_0_lambdaB_0_RR.dat')
data_RR_By_3T  = np.loadtxt('./RR/By/By_3T/data_theta90_lambdaSO_0.006_B_mag_3_phi_90_lambdaA_0_lambdaB_0_RR.dat')
data_RR_By_m1T = np.loadtxt('./RR/By/By_-1T/data_theta90_lambdaSO_0.006_B_mag_-1_phi_90_lambdaA_0_lambdaB_0_RR.dat')
data_RR_By_m2T = np.loadtxt('./RR/By/By_-2T/data_theta90_lambdaSO_0.006_B_mag_-2_phi_90_lambdaA_0_lambdaB_0_RR.dat')
data_RR_By_m3T = np.loadtxt('./RR/By/By_-3T/data_theta90_lambdaSO_0.006_B_mag_-3_phi_90_lambdaA_0_lambdaB_0_RR.dat')



#load also the data for varying Bs

#CR
data_CR_mu_100_Bx = np.loadtxt('../vary_Bzs_lambdaSO_6meV_VZ0/CR/Bx/mu_100meV/data_theta0_lambdaSO_0.006_mu_0.1_phi_0_lambdaA_0_lambdaB_0_CR.dat')
data_CR_mu_100_By = np.loadtxt('../vary_Bzs_lambdaSO_6meV_VZ0/CR/By/mu_100meV/data_theta0_lambdaSO_0.006_mu_0.1_phi_90_lambdaA_0_lambdaB_0_CR.dat')

#DR
data_DR_mu_100_Bx = np.loadtxt('../vary_Bzs_lambdaSO_6meV_VZ0/D/Bx/mu_100meV/data_theta90_lambdaSO_0.006_mu_0.1_phi_0_lambdaA_0_lambdaB_0_D.dat')
data_DR_mu_100_By = np.loadtxt('../vary_Bzs_lambdaSO_6meV_VZ0/D/By/mu_100meV/data_theta90_lambdaSO_0.006_mu_0.1_phi_90_lambdaA_0_lambdaB_0_D.dat')

#RR
data_RR_mu_100_Bx = np.loadtxt('../vary_Bzs_lambdaSO_6meV_VZ0/RR/Bx/mu_100meV/data_theta90_lambdaSO_0.006_mu_0.1_phi_0_lambdaA_0_lambdaB_0_RR.dat')
data_RR_mu_100_By = np.loadtxt('../vary_Bzs_lambdaSO_6meV_VZ0/RR/By/mu_100meV/data_theta90_lambdaSO_0.006_mu_0.1_phi_90_lambdaA_0_lambdaB_0_RR.dat')

DOS       = np.loadtxt('DOS_L4a_1salt_200phases_theta0_lambdaSO_0.006_B_mag_0_phi_0_lambdaA_0_lambdaB_0_CR.dat')
DOS_mu01  = np.loadtxt('DOS_L4a_1salt_200phases_mu0.1_theta0_lambdaSO_0.006_B_mag_0_phi_0_lambdaA_0_lambdaB_0_CR.dat')

def get_Bs(data):
    g = 42.464
    for i in range(data.shape[0]):
        data[i,0] = data[i,0] / (g*scipy.constants.physical_constants['Bohr magneton'][0] / (scipy.constants.eV))
    return data


data_CR_mu_100_Bx = get_Bs(data_CR_mu_100_Bx)
data_CR_mu_100_By = get_Bs(data_CR_mu_100_By)

data_DR_mu_100_Bx = get_Bs(data_DR_mu_100_Bx)
data_DR_mu_100_By = get_Bs(data_DR_mu_100_By)

data_RR_mu_100_Bx = get_Bs(data_RR_mu_100_Bx)
data_RR_mu_100_By = get_Bs(data_RR_mu_100_By)



a    = 0.246
L    = 300*a
hbar = scipy.constants.hbar/scipy.constants.e


def get_rates(probabilities):
    
    for i in range(probabilities.shape[0]):
        probabilities[i] = a/(L*hbar) *probabilities[i] / DOS[i,1]
        
    return probabilities

def get_rates_for_varying_B(probabilities):
    for i in range(probabilities.shape[0]):
        probabilities[i] = a/(L*hbar) *probabilities[i] / DOS_mu01[1]
        
    return probabilities
    

def remove_mu0(data_set):
    new_set = np.zeros((data_set.shape[0]-1,data_set.shape[1]))
    for mu in range(data_set.shape[0]):
        if -1e-10 > data_set[mu,0]:
            new_set[mu,0] = data_set[mu,0]
            new_set[mu,1] = data_set[mu,1]
            
        elif data_set[mu,0] > 1e-10:
            new_set[mu-1,0] = data_set[mu,0]
            new_set[mu-1,1] = data_set[mu,1]
    
    return new_set
    


data_CR_Bx_0T  =  remove_mu0(data_CR_Bx_0T )
data_CR_Bx_1T  =  remove_mu0(data_CR_Bx_1T )
data_CR_Bx_2T  =  remove_mu0(data_CR_Bx_2T )
data_CR_Bx_3T  =  remove_mu0(data_CR_Bx_3T )
data_CR_Bx_m1T =  remove_mu0(data_CR_Bx_m1T)
data_CR_Bx_m2T =  remove_mu0(data_CR_Bx_m2T)
data_CR_Bx_m3T =  remove_mu0(data_CR_Bx_m3T)
                                           
#CR for By                                 
data_CR_By_0T  =  remove_mu0(data_CR_By_0T )
data_CR_By_1T  =  remove_mu0(data_CR_By_1T )
data_CR_By_2T  =  remove_mu0(data_CR_By_2T )
data_CR_By_3T  =  remove_mu0(data_CR_By_3T )
data_CR_By_m1T =  remove_mu0(data_CR_By_m1T)
data_CR_By_m2T =  remove_mu0(data_CR_By_m2T)
data_CR_By_m3T =  remove_mu0(data_CR_By_m3T)
                                           
#DR for Bx                                 
data_DR_Bx_0T  =  remove_mu0(data_DR_Bx_0T )
data_DR_Bx_1T  =  remove_mu0(data_DR_Bx_1T )
data_DR_Bx_2T  =  remove_mu0(data_DR_Bx_2T )
data_DR_Bx_3T  =  remove_mu0(data_DR_Bx_3T )
data_DR_Bx_m1T =  remove_mu0(data_DR_Bx_m1T)
data_DR_Bx_m2T =  remove_mu0(data_DR_Bx_m2T)
data_DR_Bx_m3T =  remove_mu0(data_DR_Bx_m3T)
                                           
#DR for By                                 
data_DR_By_0T  =  remove_mu0(data_DR_By_0T )
data_DR_By_1T  =  remove_mu0(data_DR_By_1T )
data_DR_By_2T  =  remove_mu0(data_DR_By_2T )
data_DR_By_3T  =  remove_mu0(data_DR_By_3T )
data_DR_By_m1T =  remove_mu0(data_DR_By_m1T)
data_DR_By_m2T =  remove_mu0(data_DR_By_m2T)
data_DR_By_m3T =  remove_mu0(data_DR_By_m3T)
                                          
                                          
#RR for Bx                   #RR for Bx   
data_RR_Bx_0T  =  remove_mu0(data_RR_Bx_0T )
data_RR_Bx_1T  =  remove_mu0(data_RR_Bx_1T )
data_RR_Bx_2T  =  remove_mu0(data_RR_Bx_2T )
data_RR_Bx_3T  =  remove_mu0(data_RR_Bx_3T )
data_RR_Bx_m1T =  remove_mu0(data_RR_Bx_m1T)
data_RR_Bx_m2T =  remove_mu0(data_RR_Bx_m2T)
data_RR_Bx_m3T =  remove_mu0(data_RR_Bx_m3T)
                                           
#RR for By                   #RR for By    
data_RR_By_0T  =  remove_mu0(data_RR_By_0T )
data_RR_By_1T  =  remove_mu0(data_RR_By_1T )
data_RR_By_2T  =  remove_mu0(data_RR_By_2T )
data_RR_By_3T  =  remove_mu0(data_RR_By_3T )
data_RR_By_m1T =  remove_mu0(data_RR_By_m1T)
data_RR_By_m2T =  remove_mu0(data_RR_By_m2T)
data_RR_By_m3T =  remove_mu0(data_RR_By_m3T)

DOS = remove_mu0(DOS)
        

#--------------------------------------------------------------------------------------------------------------------------------


s = 6
#----------------------------------------------------------plot current densities-------------------------------------------------#
fig, axs = plt.subplots(2, 3, figsize=(16, 6))

#-------------------------------------------------------first plot---------------------------------------------------------------------
axs[0,0].set_title(r'$CR, B_x$')
axs[0,0].plot(data_CR_Bx_3T[:,0],get_rates(data_CR_Bx_3T[:,1])     ,color='C3',label=r'$B=3$ T')
axs[0,0].plot(data_CR_Bx_2T[:,0],get_rates(data_CR_Bx_2T[:,1])     ,color='C2',label=r'$B=2$ T')
axs[0,0].plot(data_CR_Bx_1T[:,0],get_rates(data_CR_Bx_1T[:,1])     ,color='C1',label=r'$B=1$ T')
axs[0,0].plot(data_CR_Bx_0T[:,0],get_rates(data_CR_Bx_0T[:,1])     ,color='k' ,label=r'$B=0$')
axs[0,0].scatter(data_CR_Bx_m1T[:,0],get_rates(data_CR_Bx_m1T[:,1]),color='C1', s=s,label=r'$B=-1$ T')
axs[0,0].scatter(data_CR_Bx_m2T[:,0],get_rates(data_CR_Bx_m2T[:,1]),color='C2', s=s,label=r'$B=-2$ T')
axs[0,0].scatter(data_CR_Bx_m3T[:,0],get_rates(data_CR_Bx_m3T[:,1]),color='C3', s=s,label=r'$B=-3$ T')
axs[0,0].set_ylabel(r'$1/\tau_s [1/s]$',fontsize=16)
#axs[0,0].legend()
#axs[0,0].set_xlabel('x')
#axs[0,0].set_xlim(0,196)
axs[0,0].set_ylim(0.5*1e12,3.5*1e12)



# Create a set of inset Axes: these should fill the bounding box allocated to them.
ax2_00 = plt.axes([0,0,1,1],label='00')
# Manually set the position and relative size of the inset axes within ax1
ip_00 = InsetPosition(axs[0,0], [0.32,0.64,0.35,0.35])
ax2_00.set_axes_locator(ip_00)

#ax2.set_xlim(0.35,0.65)
#ax2.set_ylim(134,138)

# The data: only display for edge of first Landau level
ax2_00.plot(data_CR_mu_100_Bx[:,0], get_rates_for_varying_B(data_CR_mu_100_Bx[:,1:]), c='black', mew=2, alpha=0.8)
ax2_00.set_xlabel(r'$B [T]$')

#ax2.xaxis.set_ticklabels([])
#ax2.yaxis.set_ticklabels([])



#---------------------------------------------------------------------------------------------------------------------------

#-----------------------------------------------------------second plot-----------------------------------------------------------
axs[1,0].set_title(r'$CR, B_y$')
axs[1,0].plot(data_CR_By_3T[:,0],get_rates(data_CR_By_3T[:,1])     ,color='C3',label=r'$B=3$ T')
axs[1,0].plot(data_CR_By_2T[:,0],get_rates(data_CR_By_2T[:,1])     ,color='C2',label=r'$B=2$ T')
axs[1,0].plot(data_CR_By_1T[:,0],get_rates(data_CR_By_1T[:,1])     ,color='C1',label=r'$B=1$ T')
axs[1,0].plot(data_CR_By_0T[:,0],get_rates(data_CR_By_0T[:,1])     ,color='k' ,label=r'$B=0$')
axs[1,0].scatter(data_CR_By_m1T[:,0],get_rates(data_CR_By_m1T[:,1]),color='C1', s=s,label=r'$B=-1$ T')
axs[1,0].scatter(data_CR_By_m2T[:,0],get_rates(data_CR_By_m2T[:,1]),color='C2', s=s,label=r'$B=-2$ T')
axs[1,0].scatter(data_CR_By_m3T[:,0],get_rates(data_CR_By_m3T[:,1]),color='C3', s=s,label=r'$B=-3$ T')
axs[1,0].set_ylabel(r'$1/\tau_s [1/s]$',fontsize=16)
#axs[1,0].legend()
axs[1,0].set_xlabel(r'$\mu$ [eV]')
axs[1,0].set_ylim(0.5*1e12,3.5*1e12)

# Create a set of inset Axes: these should fill the bounding box allocated to them.
ax2_10 = plt.axes([0,0,1,1],label='10')
# Manually set the position and relative size of the inset axes within ax1
ip_10 = InsetPosition(axs[1,0], [0.32,0.64,0.35,0.35])
ax2_10.set_axes_locator(ip_10)

# The data: only display for edge of first Landau level
ax2_10.plot(data_CR_mu_100_By[:,0], get_rates_for_varying_B(data_CR_mu_100_By[:,1:]), c='black', mew=2, alpha=0.8)
ax2_10.set_xlabel(r'$B [T]$')
#---------------------------------------------------------------------------------------------------------------------------------

#-------------------------------------------------------third plot---------------------------------------------------------------------
axs[0,1].set_title(r'$D, B_x$')
axs[0,1].plot(data_DR_Bx_3T[:,0],get_rates(data_DR_Bx_3T[:,1])     ,color='C3',label=r'$B=3$ T')
axs[0,1].plot(data_DR_Bx_2T[:,0],get_rates(data_DR_Bx_2T[:,1])     ,color='C2',label=r'$B=2$ T')
axs[0,1].plot(data_DR_Bx_1T[:,0],get_rates(data_DR_Bx_1T[:,1])     ,color='C1',label=r'$B=1$ T')
axs[0,1].plot(data_DR_Bx_0T[:,0],get_rates(data_DR_Bx_0T[:,1])     ,color='k' ,label=r'$B=0$')
axs[0,1].scatter(data_DR_Bx_m1T[:,0],get_rates(data_DR_Bx_m1T[:,1]),color='C1', s=s,label=r'$B=-1$ T')
axs[0,1].scatter(data_DR_Bx_m2T[:,0],get_rates(data_DR_Bx_m2T[:,1]),color='C2', s=s,label=r'$B=-2$ T')
axs[0,1].scatter(data_DR_Bx_m3T[:,0],get_rates(data_DR_Bx_m3T[:,1]),color='C3', s=s,label=r'$B=-3$ T')
axs[0,1].set_ylabel(r'$1/\tau_s [1/s]$',fontsize=16)
axs[0,1].set_ylim(0.5*1e12,3.5*1e12)


# Create a set of inset Axes: these should fill the bounding box allocated to them.
ax2_01 = plt.axes([0,0,1,1],label='01')
# Manually set the position and relative size of the inset axes within ax1
ip_01 = InsetPosition(axs[0,1], [0.32,0.64,0.35,0.35])
ax2_01.set_axes_locator(ip_01)

# The data: only display for edge of first Landau level
ax2_01.plot(data_DR_mu_100_Bx[:,0], get_rates_for_varying_B(data_DR_mu_100_Bx[:,1:]), c='black', mew=2, alpha=0.8)
ax2_01.set_xlabel(r'$B [T]$')
#---------------------------------------------------------------------------------------------------------------------------

#-----------------------------------------------------------fourth plot-----------------------------------------------------------
axs[1,1].set_title(r'$D, B_y$')
axs[1,1].plot(data_DR_By_3T[:,0],get_rates(data_DR_By_3T[:,1])     ,color='C3',label=r'$B=3$ T')
axs[1,1].plot(data_DR_By_2T[:,0],get_rates(data_DR_By_2T[:,1])     ,color='C2',label=r'$B=2$ T')
axs[1,1].plot(data_DR_By_1T[:,0],get_rates(data_DR_By_1T[:,1])     ,color='C1',label=r'$B=1$ T')
axs[1,1].plot(data_DR_By_0T[:,0],get_rates(data_DR_By_0T[:,1])     ,color='k' ,label=r'$B=0$')
axs[1,1].scatter(data_DR_By_m1T[:,0],get_rates(data_DR_By_m1T[:,1]),color='C1', s=s,label=r'$B=-1$ T')
axs[1,1].scatter(data_DR_By_m2T[:,0],get_rates(data_DR_By_m2T[:,1]),color='C2', s=s,label=r'$B=-2$ T')
axs[1,1].scatter(data_DR_By_m3T[:,0],get_rates(data_DR_By_m3T[:,1]),color='C3', s=s,label=r'$B=-3$ T')
axs[1,1].set_ylabel(r'$1/\tau_s [1/s]$',fontsize=16)
#axs[1,0].legend()
axs[1,1].set_xlabel(r'$\mu$ [eV]')
axs[1,1].set_ylim(0.5*1e12,3.5*1e12)

# Create a set of inset Axes: these should fill the bounding box allocated to them.
ax2_11 = plt.axes([0,0,1,1],label='11')
# Manually set the position and relative size of the inset axes within ax1
ip_11 = InsetPosition(axs[1,1], [0.32,0.64,0.35,0.35])
ax2_11.set_axes_locator(ip_11)

# The data: only display for edge of first Landau level
ax2_11.plot(data_DR_mu_100_By[:,0], get_rates_for_varying_B(data_DR_mu_100_By[:,1:]), c='black', mew=2, alpha=0.8)
ax2_11.set_xlabel(r'$B [T]$')
#----------------------------------------------------------------------------------------------------------------------------------


#-------------------------------------------------------fith plot---------------------------------------------------------------------
axs[0,2].set_title(r'$RR, B_x$')
axs[0,2].plot(data_RR_Bx_3T[:,0],get_rates(data_RR_Bx_3T[:,1])     ,color='C3',label=r'$B=3$ T')
axs[0,2].plot(data_RR_Bx_2T[:,0],get_rates(data_RR_Bx_2T[:,1])     ,color='C2',label=r'$B=2$ T')
axs[0,2].plot(data_RR_Bx_1T[:,0],get_rates(data_RR_Bx_1T[:,1])     ,color='C1',label=r'$B=1$ T')
axs[0,2].plot(data_RR_Bx_0T[:,0],get_rates(data_RR_Bx_0T[:,1])     ,color='k' ,label=r'$B=0$')
axs[0,2].scatter(data_RR_Bx_m1T[:,0],get_rates(data_RR_Bx_m1T[:,1]),color='C1', s=s,label=r'$B=-1$ T')
axs[0,2].scatter(data_RR_Bx_m2T[:,0],get_rates(data_RR_Bx_m2T[:,1]),color='C2', s=s,label=r'$B=-2$ T')
axs[0,2].scatter(data_RR_Bx_m3T[:,0],get_rates(data_RR_Bx_m3T[:,1]),color='C3', s=s,label=r'$B=-3$ T')
axs[0,2].set_ylabel(r'$1/\tau_s [1/s]$',fontsize=16)
axs[0,2].set_ylim(0.5*1e12,3.5*1e12)

# Create a set of inset Axes: these should fill the bounding box allocated to them.
ax2_02 = plt.axes([0,0,1,1],label='02')
# Manually set the position and relative size of the inset axes within ax1
ip_02 = InsetPosition(axs[0,2], [0.32,0.64,0.35,0.35])
ax2_02.set_axes_locator(ip_02)

# The data: only display for edge of first Landau level
ax2_02.plot(data_RR_mu_100_Bx[:,0], get_rates_for_varying_B(data_RR_mu_100_Bx[:,1:]), c='black', mew=2, alpha=0.8)
ax2_02.set_xlabel(r'$B [T]$')
#---------------------------------------------------------------------------------------------------------------------------

#-----------------------------------------------------------sixth plot-----------------------------------------------------------
axs[1,2].set_title(r'$CR, B_y$')
axs[1,2].plot(data_RR_By_3T[:,0],get_rates(data_RR_By_3T[:,1])     ,color='C3',label=r'$B=3$ T')
axs[1,2].plot(data_RR_By_2T[:,0],get_rates(data_RR_By_2T[:,1])     ,color='C2',label=r'$B=2$ T')
axs[1,2].plot(data_RR_By_1T[:,0],get_rates(data_RR_By_1T[:,1])     ,color='C1',label=r'$B=1$ T')
axs[1,2].plot(data_RR_By_0T[:,0],get_rates(data_RR_By_0T[:,1])     ,color='k' ,label=r'$B=0$')
axs[1,2].scatter(data_RR_By_m1T[:,0],get_rates(data_RR_By_m1T[:,1]),color='C1', s=s,label=r'$B=-1$ T')
axs[1,2].scatter(data_RR_By_m2T[:,0],get_rates(data_RR_By_m2T[:,1]),color='C2', s=s,label=r'$B=-2$ T')
axs[1,2].scatter(data_RR_By_m3T[:,0],get_rates(data_RR_By_m3T[:,1]),color='C3', s=s,label=r'$B=-3$ T')
axs[1,2].set_ylabel(r'$1/\tau_s [1/s]$',fontsize=16)
axs[1,2].set_xlabel(r'$\mu$ [eV]')
axs[1,2].set_ylim(0.5*1e12,3.5*1e12)


# Create a set of inset Axes: these should fill the bounding box allocated to them.
ax2_12 = plt.axes([0,0,1,1],label='12')
# Manually set the position and relative size of the inset axes within ax1
ip_12 = InsetPosition(axs[1,2], [0.32,0.64,0.35,0.35])
ax2_12.set_axes_locator(ip_12)

# The data: only display for edge of first Landau level
ax2_12.plot(data_RR_mu_100_By[:,0], get_rates_for_varying_B(data_RR_mu_100_By[:,1:]), c='black', mew=2, alpha=0.8)
ax2_12.set_xlabel(r'$B [T]$')
#---------------------------------------------------------------------------------------------------------------------------------



handles, labels = axs[1,0].get_legend_handles_labels()
fig.legend(handles, labels, loc='lower center',ncol=7,prop={'size': 14}, bbox_to_anchor=(0.5, -0.1))


axs[0,0].annotate("(a)", xy=(-0.16, 1.02), xycoords="axes fraction", fontsize=13)
axs[0,1].annotate("(b)", xy=(-0.16, 1.02), xycoords="axes fraction", fontsize=13)
axs[0,2].annotate("(c)", xy=(-0.16, 1.02), xycoords="axes fraction", fontsize=13)
axs[1,0].annotate("(d)", xy=(-0.16, 1.02), xycoords="axes fraction", fontsize=13)
axs[1,1].annotate("(e)", xy=(-0.16, 1.02), xycoords="axes fraction", fontsize=13)
axs[1,2].annotate("(f)", xy=(-0.16, 1.02), xycoords="axes fraction", fontsize=13)


# set the spacing between subplots
plt.subplots_adjust(wspace=0.45, 
                    hspace=0.35)
fig.savefig('figure_rates.pdf', bbox_inches='tight', pad_inches=0.1)
#plt.show()
#exit()
